Index: src/sas/qtgui/MainWindow/DataState.py
===================================================================
--- src/sas/qtgui/MainWindow/DataState.py	(revision dc5ef150e8b37e01a3b7e253eb5b66d3b82de99c)
+++ src/sas/qtgui/MainWindow/DataState.py	(revision 749b715f280e81297ccee885592a53f964909d62)
Index: src/sas/qtgui/Plotting/ConvertUnits.py
===================================================================
--- src/sas/qtgui/Plotting/ConvertUnits.py	(revision dc5ef150e8b37e01a3b7e253eb5b66d3b82de99c)
+++ src/sas/qtgui/Plotting/ConvertUnits.py	(revision 749b715f280e81297ccee885592a53f964909d62)
Index: src/sas/qtgui/Plotting/DataTransform.py
===================================================================
--- src/sas/qtgui/Plotting/DataTransform.py	(revision dc5ef150e8b37e01a3b7e253eb5b66d3b82de99c)
+++ src/sas/qtgui/Plotting/DataTransform.py	(revision 749b715f280e81297ccee885592a53f964909d62)
Index: src/sas/qtgui/Plotting/LineModel.py
===================================================================
--- src/sas/qtgui/Plotting/LineModel.py	(revision dc5ef150e8b37e01a3b7e253eb5b66d3b82de99c)
+++ src/sas/qtgui/Plotting/LineModel.py	(revision 749b715f280e81297ccee885592a53f964909d62)
Index: src/sas/qtgui/Plotting/Plotter.py
===================================================================
--- src/sas/qtgui/Plotting/Plotter.py	(revision f0bb71111cd83022768469968b3891e8656d0417)
+++ src/sas/qtgui/Plotting/Plotter.py	(revision 749b715f280e81297ccee885592a53f964909d62)
@@ -56,4 +56,7 @@
         self.xLabel = "%s(%s)"%(value._xaxis, value._xunit)
         self.yLabel = "%s(%s)"%(value._yaxis, value._yunit)
+        if value.isSesans:
+            self.xscale = 'linear'
+            self.yscale = 'linear'
         self.title(title=value.name)
 
Index: src/sas/qtgui/Plotting/PlotterData.py
===================================================================
--- src/sas/qtgui/Plotting/PlotterData.py	(revision fef38e8f19a097daafbdbdd6edb786c11fb2b995)
+++ src/sas/qtgui/Plotting/PlotterData.py	(revision 749b715f280e81297ccee885592a53f964909d62)
@@ -54,4 +54,5 @@
         self.yaxis(data1d._yaxis, data1d._yunit)
         self.title = data1d.title
+        self.isSesans = data1d.isSesans
         
     def __str__(self):
Index: src/sas/qtgui/Plotting/Slicers/Arc.py
===================================================================
--- src/sas/qtgui/Plotting/Slicers/Arc.py	(revision dc5ef150e8b37e01a3b7e253eb5b66d3b82de99c)
+++ src/sas/qtgui/Plotting/Slicers/Arc.py	(revision 749b715f280e81297ccee885592a53f964909d62)
Index: src/sas/qtgui/Plotting/Slicers/BaseInteractor.py
===================================================================
--- src/sas/qtgui/Plotting/Slicers/BaseInteractor.py	(revision dc5ef150e8b37e01a3b7e253eb5b66d3b82de99c)
+++ src/sas/qtgui/Plotting/Slicers/BaseInteractor.py	(revision 749b715f280e81297ccee885592a53f964909d62)
Index: src/sas/qtgui/Plotting/UnitTesting/PlotterTest.py
===================================================================
--- src/sas/qtgui/Plotting/UnitTesting/PlotterTest.py	(revision b2a5042a962948503c534876c6215195a324cdc9)
+++ src/sas/qtgui/Plotting/UnitTesting/PlotterTest.py	(revision 749b715f280e81297ccee885592a53f964909d62)
@@ -73,4 +73,25 @@
 
         self.assertEqual(self.plotter.ax.get_yscale(), 'log')
+        self.assertTrue(FigureCanvas.draw.called)
+
+    def testPlotWithSesans(self):
+        """ Ensure that Sesans data is plotted in linear cooredinates"""
+        data = Data1D(x=[1.0, 2.0, 3.0],
+                      y=[10.0, 11.0, 12.0],
+                      dx=[0.1, 0.2, 0.3],
+                      dy=[0.1, 0.2, 0.3])
+        data.title = "Sesans data"
+        data.name = "Test Sesans"
+        data.isSesans = True
+        data.id = 2
+
+        self.plotter.data = data
+        self.plotter.show()
+        FigureCanvas.draw = MagicMock()
+
+        self.plotter.plot(hide_error=True)
+
+        self.assertEqual(self.plotter.ax.get_xscale(), 'linear')
+        self.assertEqual(self.plotter.ax.get_yscale(), 'linear')
         self.assertTrue(FigureCanvas.draw.called)
 
Index: src/sas/qtgui/Utilities/CustomDir.py
===================================================================
--- src/sas/qtgui/Utilities/CustomDir.py	(revision dc5ef150e8b37e01a3b7e253eb5b66d3b82de99c)
+++ src/sas/qtgui/Utilities/CustomDir.py	(revision 749b715f280e81297ccee885592a53f964909d62)
Index: src/sas/qtgui/Utilities/GenericReader.py
===================================================================
--- src/sas/qtgui/Utilities/GenericReader.py	(revision dc5ef150e8b37e01a3b7e253eb5b66d3b82de99c)
+++ src/sas/qtgui/Utilities/GenericReader.py	(revision 749b715f280e81297ccee885592a53f964909d62)
Index: src/sas/sascalc/dataloader/data_info.py
===================================================================
--- src/sas/sascalc/dataloader/data_info.py	(revision deaa0c6b324db1003ba4999149364cd82185294e)
+++ src/sas/sascalc/dataloader/data_info.py	(revision 749b715f280e81297ccee885592a53f964909d62)
@@ -775,4 +775,5 @@
         clone.meta_data = deepcopy(self.meta_data)
         clone.errors = deepcopy(self.errors)
+        clone.isSesans = self.isSesans
 
         return clone