Index: lculatorview/src/sans/media/kiessig_calculator_help.html
===================================================================
--- calculatorview/src/sans/media/kiessig_calculator_help.html	(revision 331a5108b0e8d8317627082fbaa7444bcfaf935b)
+++ 	(revision )
@@ -1,27 +1,0 @@
-<html>
-<body>
-<h4>Kiessig Thickness Calculator</h4>
-<ul>
-<li><a href="#Description">Description:</a></li>
-<li><a href="#HowTo">HowTo?</a></li>
-
-</ul>
-<h5><a name="Description">Description</a></h5>
-<p>
-This tool is to approximately estimate the thickness of a layer
- or the diameter of particles from the Kiessig fringe in 
- SANS/NR data, and uses the Kiessig relation;
- thickness = 2*Pi/fringe_width.
-  
-</p>
-
-
-<h5><a name="HowTo">HowTo?</a></h5>
-<p>
-To get a rough thickness or particle size, just type the Kiessig fringe width (in the 1/A unit)
- and click on the 'Compute' button. Then the output value will be show up in the 'Thickness' text box.</p>
-
-
-</body>
-
-</html>
Index: lculatorview/src/sans/media/resolution_calculator_help.html
===================================================================
--- calculatorview/src/sans/media/resolution_calculator_help.html	(revision 331a5108b0e8d8317627082fbaa7444bcfaf935b)
+++ 	(revision )
@@ -1,41 +1,0 @@
-<html>
-<body>
-<h4>SANS Q Resolution Estimator</h4>
-<ul>
-<li><a href="#Description">Description:</a></li>
-<li><a href="#HowTo">HowTo?</a></li>
-
-</ul>
-<h5><a name="Description">Description</a></h5>
-<p>
-This tool is to approximately estimate the resolution of Q based on the
-SANS instrumental parameter values assuming that the detector is flat 
-and vertical to the incident beam direction.
-</p>
-
-
-<h5><a name="HowTo">HowTo?</a></h5>
-<p>
-1. Change the default values of the instrumental parameters as desired,
-and type the qx and qy value where the resolution
-is calculated. 
-</p>
-<p>
-2. Select the coordinate system from the radio button.
-</p>
-<p>
-3. Click on the compute button.
-</p>
-<p> 
-4. 1D and 2D dQ will be displayed in the text-box at the bottom of 
-the panel. Two dimensional resolution weight distribution 
-(2D elliptical Gaussian function) will also be 
-displayed in the plot panel even if the Q inputs are outside 
-of the detector limit.
-The red lines indicate the limits of the detector. 
-</p>
-<p><img src="resolution_tutor.gif">
-</p>
-</body>
-
-</html>
Index: lculatorview/src/sans/media/sld_calculator_help.html
===================================================================
--- calculatorview/src/sans/media/sld_calculator_help.html	(revision 331a5108b0e8d8317627082fbaa7444bcfaf935b)
+++ 	(revision )
@@ -1,42 +1,0 @@
-<html>
-<body>
-<h4>Scattering Length Density (SLD) Calculator</h4>
-<ul>
-<li><a href="#SLD_calculator">Description</a></li>
-<li><a href="#How to use">How to format the compound name?</a></li>
-</ul>
-<h5><a name="SLD_calculator">Description</a></h5>
-<p>
-The neutron scattering length density is defined as: <br> 
-SLD = (b_c1 +b_c2+...+b_cn )/Vm  <br> where b_ci is the bound coherent scattering length of ith of 
-n atoms in a molecule with the molecular volume Vm
-</p>
-
-
-<h5><a name="How to use">How to format the compound name?</a></h5>
-<p>
-To calculate scattering length densities enter a compound and
-a mass density and click "Calculate". Enter a wavelength value is optional and its default 
-value will be 6.0A.
-</p> 
-<p>
-<ul>
-<li>Formula strings consist of counts and atoms such as "CaCO3+6H2O".</li>
-<li>Groups can be separated by <b>'+'</b> or <b>space</b>, so "CaCO3 6H2O" works as well.</li>
-<li>Groups and be defined using parentheses, such as "CaCO3(H2O)6".</li>
-<li>Parentheses can nest: "(CaCO3(H2O)6)1".</li>
-<li>Isotopes are represented by index, e.g., "CaCO[18]3+6H2O".</li>
-More examples: H[1], H[2].
-<li>Counts can be integer or decimal, e.g. "CaCO3+(3HO0.5)2".</li>
-Other compositions can be calculated as well,<br>
-for example a 70-30 mixture of H2O/D2O can be written as <b>H14O7+ D6O3</b><br>
-or more simply <b>H7D3O5 <\b>(i.e. 7 hydrogens, 3 deuteriums, and 5 oxygens)<br>
-and the mass density calculated based on the percentages of H and D. 
-Type for example "C[13]6 H[2]12 O[18]6" for C(13)6H(2)12O(18)6 (6 Carbon-13 atoms, 12 deuterium atoms, and 6 Oxygen-18 atoms) 
-
-</ul>
-</p>
-
-</body>
-
-<\html>
Index: lculatorview/src/sans/media/slit_calculator_help.html
===================================================================
--- calculatorview/src/sans/media/slit_calculator_help.html	(revision 331a5108b0e8d8317627082fbaa7444bcfaf935b)
+++ 	(revision )
@@ -1,33 +1,0 @@
-<html>
-<body>
-<h4>Slit Size Calculator</h4>
-<ul>
-<li><a href="#Description">Description:</a></li>
-<li><a href="#HowTo">HowTo?</a></li>
-<li><a href="#Note">Note</a></li>
-</ul>
-<h5><a name="Description">Description</a></h5>
-<p>
-This tool is for X-ray users to calculate the slit size (FWHM/2) 
-for smearing  based on their half beam profile data (SAXSess). 
-</p>
-
-
-<h5><a name="HowTo">HowTo?</a></h5>
-<p>
-To calculate the slit size (FWHM/2), just load the beam profile data using the browse button. </p>
-<p>
-Once a data is loaded, the slit size will be computed and show up in the text box. </p>
-<p>
-Because the unit is not specified in the data file, we do not convert it into 1/A so that users are responsible for converting the unit.
-</p>
-
-<h5><a name="Note">Note: </a></h5>
-This slit size calculator is working only for a beam profile data produced by 'SAXSess'. 
-
-<p>
-To see the file format, check the file, 'beam profile.DAT', in the 'test' folder of SansView. 
-</p>
-</body>
-
-</html>
Index: calculatorview/src/sans/perspectives/media/kiessig_calculator_help.html
===================================================================
--- calculatorview/src/sans/perspectives/media/kiessig_calculator_help.html	(revision 766f715536f532bcb0678933d25c36ef34fe5c87)
+++ calculatorview/src/sans/perspectives/media/kiessig_calculator_help.html	(revision 766f715536f532bcb0678933d25c36ef34fe5c87)
@@ -0,0 +1,27 @@
+<html>
+<body>
+<h4>Kiessig Thickness Calculator</h4>
+<ul>
+<li><a href="#Description">Description:</a></li>
+<li><a href="#HowTo">HowTo?</a></li>
+
+</ul>
+<h5><a name="Description">Description</a></h5>
+<p>
+This tool is to approximately estimate the thickness of a layer
+ or the diameter of particles from the Kiessig fringe in 
+ SANS/NR data, and uses the Kiessig relation;
+ thickness = 2*Pi/fringe_width.
+  
+</p>
+
+
+<h5><a name="HowTo">HowTo?</a></h5>
+<p>
+To get a rough thickness or particle size, just type the Kiessig fringe width (in the 1/A unit)
+ and click on the 'Compute' button. Then the output value will be show up in the 'Thickness' text box.</p>
+
+
+</body>
+
+</html>
Index: calculatorview/src/sans/perspectives/media/resolution_calculator_help.html
===================================================================
--- calculatorview/src/sans/perspectives/media/resolution_calculator_help.html	(revision 766f715536f532bcb0678933d25c36ef34fe5c87)
+++ calculatorview/src/sans/perspectives/media/resolution_calculator_help.html	(revision 766f715536f532bcb0678933d25c36ef34fe5c87)
@@ -0,0 +1,41 @@
+<html>
+<body>
+<h4>SANS Q Resolution Estimator</h4>
+<ul>
+<li><a href="#Description">Description:</a></li>
+<li><a href="#HowTo">HowTo?</a></li>
+
+</ul>
+<h5><a name="Description">Description</a></h5>
+<p>
+This tool is to approximately estimate the resolution of Q based on the
+SANS instrumental parameter values assuming that the detector is flat 
+and vertical to the incident beam direction.
+</p>
+
+
+<h5><a name="HowTo">HowTo?</a></h5>
+<p>
+1. Change the default values of the instrumental parameters as desired,
+and type the qx and qy value where the resolution
+is calculated. 
+</p>
+<p>
+2. Select the coordinate system from the radio button.
+</p>
+<p>
+3. Click on the compute button.
+</p>
+<p> 
+4. 1D and 2D dQ will be displayed in the text-box at the bottom of 
+the panel. Two dimensional resolution weight distribution 
+(2D elliptical Gaussian function) will also be 
+displayed in the plot panel even if the Q inputs are outside 
+of the detector limit.
+The red lines indicate the limits of the detector. 
+</p>
+<p><img src="resolution_tutor.gif">
+</p>
+</body>
+
+</html>
Index: calculatorview/src/sans/perspectives/media/sld_calculator_help.html
===================================================================
--- calculatorview/src/sans/perspectives/media/sld_calculator_help.html	(revision 766f715536f532bcb0678933d25c36ef34fe5c87)
+++ calculatorview/src/sans/perspectives/media/sld_calculator_help.html	(revision 766f715536f532bcb0678933d25c36ef34fe5c87)
@@ -0,0 +1,42 @@
+<html>
+<body>
+<h4>Scattering Length Density (SLD) Calculator</h4>
+<ul>
+<li><a href="#SLD_calculator">Description</a></li>
+<li><a href="#How to use">How to format the compound name?</a></li>
+</ul>
+<h5><a name="SLD_calculator">Description</a></h5>
+<p>
+The neutron scattering length density is defined as: <br> 
+SLD = (b_c1 +b_c2+...+b_cn )/Vm  <br> where b_ci is the bound coherent scattering length of ith of 
+n atoms in a molecule with the molecular volume Vm
+</p>
+
+
+<h5><a name="How to use">How to format the compound name?</a></h5>
+<p>
+To calculate scattering length densities enter a compound and
+a mass density and click "Calculate". Enter a wavelength value is optional and its default 
+value will be 6.0A.
+</p> 
+<p>
+<ul>
+<li>Formula strings consist of counts and atoms such as "CaCO3+6H2O".</li>
+<li>Groups can be separated by <b>'+'</b> or <b>space</b>, so "CaCO3 6H2O" works as well.</li>
+<li>Groups and be defined using parentheses, such as "CaCO3(H2O)6".</li>
+<li>Parentheses can nest: "(CaCO3(H2O)6)1".</li>
+<li>Isotopes are represented by index, e.g., "CaCO[18]3+6H2O".</li>
+More examples: H[1], H[2].
+<li>Counts can be integer or decimal, e.g. "CaCO3+(3HO0.5)2".</li>
+Other compositions can be calculated as well,<br>
+for example a 70-30 mixture of H2O/D2O can be written as <b>H14O7+ D6O3</b><br>
+or more simply <b>H7D3O5 <\b>(i.e. 7 hydrogens, 3 deuteriums, and 5 oxygens)<br>
+and the mass density calculated based on the percentages of H and D. 
+Type for example "C[13]6 H[2]12 O[18]6" for C(13)6H(2)12O(18)6 (6 Carbon-13 atoms, 12 deuterium atoms, and 6 Oxygen-18 atoms) 
+
+</ul>
+</p>
+
+</body>
+
+<\html>
Index: calculatorview/src/sans/perspectives/media/slit_calculator_help.html
===================================================================
--- calculatorview/src/sans/perspectives/media/slit_calculator_help.html	(revision 766f715536f532bcb0678933d25c36ef34fe5c87)
+++ calculatorview/src/sans/perspectives/media/slit_calculator_help.html	(revision 766f715536f532bcb0678933d25c36ef34fe5c87)
@@ -0,0 +1,33 @@
+<html>
+<body>
+<h4>Slit Size Calculator</h4>
+<ul>
+<li><a href="#Description">Description:</a></li>
+<li><a href="#HowTo">HowTo?</a></li>
+<li><a href="#Note">Note</a></li>
+</ul>
+<h5><a name="Description">Description</a></h5>
+<p>
+This tool is for X-ray users to calculate the slit size (FWHM/2) 
+for smearing  based on their half beam profile data (SAXSess). 
+</p>
+
+
+<h5><a name="HowTo">HowTo?</a></h5>
+<p>
+To calculate the slit size (FWHM/2), just load the beam profile data using the browse button. </p>
+<p>
+Once a data is loaded, the slit size will be computed and show up in the text box. </p>
+<p>
+Because the unit is not specified in the data file, we do not convert it into 1/A so that users are responsible for converting the unit.
+</p>
+
+<h5><a name="Note">Note: </a></h5>
+This slit size calculator is working only for a beam profile data produced by 'SAXSess'. 
+
+<p>
+To see the file format, check the file, 'beam profile.DAT', in the 'test' folder of SansView. 
+</p>
+</body>
+
+</html>