Index: sanscalculator/docs/sphinx/html/_sources/api/index.txt
===================================================================
--- sanscalculator/docs/sphinx/html/_sources/api/index.txt	(revision 771fe98097297bf37450a51676f6d5c918873ead)
+++ sanscalculator/docs/sphinx/html/_sources/api/index.txt	(revision 771fe98097297bf37450a51676f6d5c918873ead)
@@ -0,0 +1,19 @@
+.. Autogenerated by genmods.py
+
+.. _api-index:
+
+##############################################################################
+   Reference
+##############################################################################
+
+.. only:: html
+
+   :Release: |version|
+   :Date: |today|
+
+.. toctree::
+
+   instrument.rst
+   slit_length_calculator.rst
+   kiessig_calculator.rst
+   resolution_calculator.rst
Index: sanscalculator/docs/sphinx/html/_sources/api/instrument.txt
===================================================================
--- sanscalculator/docs/sphinx/html/_sources/api/instrument.txt	(revision 771fe98097297bf37450a51676f6d5c918873ead)
+++ sanscalculator/docs/sphinx/html/_sources/api/instrument.txt	(revision 771fe98097297bf37450a51676f6d5c918873ead)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+Instrument
+******************************************************************************
+
+:mod:`sans.calculator.instrument`
+==============================================================================
+
+.. automodule:: sans.calculator.instrument
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+
Index: sanscalculator/docs/sphinx/html/_sources/api/kiessig_calculator.txt
===================================================================
--- sanscalculator/docs/sphinx/html/_sources/api/kiessig_calculator.txt	(revision 771fe98097297bf37450a51676f6d5c918873ead)
+++ sanscalculator/docs/sphinx/html/_sources/api/kiessig_calculator.txt	(revision 771fe98097297bf37450a51676f6d5c918873ead)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+Kiessig Calculator
+******************************************************************************
+
+:mod:`sans.calculator.kiessig_calculator`
+==============================================================================
+
+.. automodule:: sans.calculator.kiessig_calculator
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+
Index: sanscalculator/docs/sphinx/html/_sources/api/resolution_calculator.txt
===================================================================
--- sanscalculator/docs/sphinx/html/_sources/api/resolution_calculator.txt	(revision 771fe98097297bf37450a51676f6d5c918873ead)
+++ sanscalculator/docs/sphinx/html/_sources/api/resolution_calculator.txt	(revision 771fe98097297bf37450a51676f6d5c918873ead)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+Resolution Calculator
+******************************************************************************
+
+:mod:`sans.calculator.resolution_calculator`
+==============================================================================
+
+.. automodule:: sans.calculator.resolution_calculator
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+
Index: sanscalculator/docs/sphinx/html/_sources/api/sld_calculator.txt
===================================================================
--- sanscalculator/docs/sphinx/html/_sources/api/sld_calculator.txt	(revision 771fe98097297bf37450a51676f6d5c918873ead)
+++ sanscalculator/docs/sphinx/html/_sources/api/sld_calculator.txt	(revision 771fe98097297bf37450a51676f6d5c918873ead)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+Sld Calculator
+******************************************************************************
+
+:mod:`sans.calculator.sld_calculator`
+==============================================================================
+
+.. automodule:: sans.calculator.sld_calculator
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+
Index: sanscalculator/docs/sphinx/html/_sources/api/slit_length_calculator.txt
===================================================================
--- sanscalculator/docs/sphinx/html/_sources/api/slit_length_calculator.txt	(revision 771fe98097297bf37450a51676f6d5c918873ead)
+++ sanscalculator/docs/sphinx/html/_sources/api/slit_length_calculator.txt	(revision 771fe98097297bf37450a51676f6d5c918873ead)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+Slit Length Calculator
+******************************************************************************
+
+:mod:`sans.calculator.slit_length_calculator`
+==============================================================================
+
+.. automodule:: sans.calculator.slit_length_calculator
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+
Index: sanscalculator/docs/sphinx/html/_sources/index.txt
===================================================================
--- sanscalculator/docs/sphinx/html/_sources/index.txt	(revision 771fe98097297bf37450a51676f6d5c918873ead)
+++ sanscalculator/docs/sphinx/html/_sources/index.txt	(revision 771fe98097297bf37450a51676f6d5c918873ead)
@@ -0,0 +1,31 @@
+.. calculator documentation master file, created by
+   sphinx-quickstart on Thu May 27 09:12:00 2010.
+   You can adapt this file completely to your liking, but it should at least
+   contain the root `toctree` directive.
+
+Calculator
+======================================
+Calculator is a package that contains other sub-modules necessary for small computations. These sub-modules
+may be independant of each other, but there are used as ``tools`` for sansview application. The calculator package
+currently contains the following sub-modules:
+
+* :ref:`sans.calculator.index`
+
+.. htmlonly::
+
+   :Release: |version|
+   :Date:    |today|
+
+   
+.. toctree::
+   :maxdepth: 2
+
+   api/index.rst
+
+Indices and tables
+==================
+
+* :ref:`genindex`
+* :ref:`modindex`
+* :ref:`search`
+