Index: doc/conf.py
===================================================================
--- doc/conf.py	(revision 39674a040d2b37f7704abd674b8a98b18ea42b4c)
+++ doc/conf.py	(revision 785cbec0749457756eec925df00538ade654c842)
@@ -36,5 +36,5 @@
               #'only_directives',
               #'matplotlib.sphinxext.mathmpl',
-              'matplotlib.sphinxext.only_directives',
+              #'matplotlib.sphinxext.only_directives',
               'matplotlib.sphinxext.plot_directive',
               'dollarmath',
Index: sasmodels/generate.py
===================================================================
--- sasmodels/generate.py	(revision 0f00d95c97536e141fcc2852f5d81a3553c3dc70)
+++ sasmodels/generate.py	(revision 785cbec0749457756eec925df00538ade654c842)
@@ -145,5 +145,5 @@
 
 :func:`load_kernel_module` loads the model definition file and
-:modelinfo:`make_model_info` parses it. :func:`make_source`
+:func:`modelinfo.make_model_info` parses it. :func:`make_source`
 converts C-based model definitions to C source code, including the
 polydispersity integral.  :func:`model_sources` returns the list of
Index: sasmodels/list_pars.py
===================================================================
--- sasmodels/list_pars.py	(revision 6d6508e66dc590f2ad678c70ef6fc78c3d4e684c)
+++ sasmodels/list_pars.py	(revision 785cbec0749457756eec925df00538ade654c842)
@@ -13,6 +13,6 @@
 import sys
 
-from .core import load_model_info
-from .compare import MODELS, columnize
+from .core import load_model_info, list_models
+from .compare import columnize
 
 def find_pars():
@@ -23,5 +23,5 @@
     """
     partable = {}
-    for name in sorted(MODELS):
+    for name in list_models():
         model_info = load_model_info(name)
         for p in model_info.parameters.kernel_parameters:
Index: sasmodels/models/fractal.py
===================================================================
--- sasmodels/models/fractal.py	(revision 42356c8890c04b71169941b12a36fc0e07e2034b)
+++ sasmodels/models/fractal.py	(revision 785cbec0749457756eec925df00538ade654c842)
@@ -7,6 +7,6 @@
 .. math::
 
-    I(q) &=& \phi\ V_{block} (\rho_{block} - \rho_{solvent})^2 P(q)S(q)
-    + background
+    I(q) = \phi\ V_\text{block} (\rho_\text{block}
+          - \rho_\text{solvent})^2 P(q)S(q) + \text{background}
 
 where $\phi$ is The volume fraction of the spherical "building block" particles
@@ -20,11 +20,12 @@
 .. math::
 
-    \begin{eqnarray}
-    P(q)&=& F(qR_0)^2 \\
-    F(q)&=& \frac{3 (sinx - x cosx)}{x^3} \\
-    V_{particle} &=& \frac{4}{3}\ \pi R_0 \\
-    S(q) &=& 1 + \frac{D_f\  \Gamma\!(D_f-1)}{[1+1/(q \xi)^2\  ]^{(D_f -1)/2}}
-    \frac{sin[(D_f-1) \tan^{-1}(q \xi) ]}{(q R_0)^{D_f}}
-    \end{eqnarray}
+    P(q)&= F(qR_0)^2
+
+    F(q)&= \frac{3 (\sin x - x \cos x)}{x^3}
+
+    V_\text{particle} &= \frac{4}{3}\ \pi R_0
+
+    S(q) &= 1 + \frac{D_f\  \Gamma\!(D_f-1)}{[1+1/(q \xi)^2\  ]^{(D_f -1)/2}}
+    \frac{\sin[(D_f-1) \tan^{-1}(q \xi) ]}{(q R_0)^{D_f}}
 
 where $\xi$ is the correlation length representing the cluster size and $D_f$
Index: sasmodels/models/onion.py
===================================================================
--- sasmodels/models/onion.py	(revision e187b252ea4d8d9787ee5c93ffcc4b9939bcee1c)
+++ sasmodels/models/onion.py	(revision 785cbec0749457756eec925df00538ade654c842)
@@ -36,5 +36,4 @@
 
     \begin{align*}
-
     f_\text{core}
         &= 4\pi\int_0^{r_\text{core}} \rho_\text{core}
@@ -75,19 +74,17 @@
 thickness of the $k^\text{th}$ shell in the equation above, respectively.
 
-For $A \gt 0$,
-
-.. math::
-    :nowrap:
-
-    \begin{align*}
+For $A > 0$,
+
+.. math::
+
     f_\text{shell} &= 4 \pi \int_{r_{\text{shell}-1}}^{r_\text{shell}}
         \left[ B\exp
             \left(A (r - r_{\text{shell}-1}) / \Delta t_\text{shell} \right) + C
-        \right] \frac{\sin(qr)}{qr}\,r^2\,\mathrm{d}r \\
+        \right] \frac{\sin(qr)}{qr}\,r^2\,\mathrm{d}r
+
     &= 3BV(r_\text{shell}) e^A h(\alpha_\text{out},\beta_\text{out})
         - 3BV(r_{\text{shell}-1}) h(\alpha_\text{in},\beta_\text{in})
         + 3CV(r_{\text{shell}}) \frac{j_1(\beta_\text{out})}{\beta_\text{out}}
         - 3CV(r_{\text{shell}-1}) \frac{j_1(\beta_\text{in})}{\beta_\text{in}}
-    \end{align*}
 
 for
@@ -102,5 +99,5 @@
          &\alpha_\text{out} &= A\frac{r_\text{shell}}{\Delta t_\text{shell}} \\
     \beta_\text{in} &= qr_{\text{shell}-1}
-        &\beta_\text{out} &= qr_\text{shell}
+        &\beta_\text{out} &= qr_\text{shell} \\
     \end{align*}
 
Index: sasmodels/models/spherical_sld.py
===================================================================
--- sasmodels/models/spherical_sld.py	(revision 50ec5155a86f50e85db2a2702dd2e7952afbf09f)
+++ sasmodels/models/spherical_sld.py	(revision 785cbec0749457756eec925df00538ade654c842)
@@ -46,5 +46,6 @@
 
 .. math::
-    f_\text{core} = 4 \pi \int_{0}^{r_\text{core}} \rho_\text{core}
+
+    f_\text{core} &= 4 \pi \int_{0}^{r_\text{core}} \rho_\text{core}
     \frac{\sin(qr)} {qr} r^2 dr =
     3 \rho_\text{core} V(r_\text{core})
@@ -52,8 +53,8 @@
     {qr_\text{core}^3} \Big]
 
-    f_{\text{inter}_i} = 4 \pi \int_{\Delta t_{ \text{inter}_i } }
+    f_{\text{inter}_i} &= 4 \pi \int_{\Delta t_{ \text{inter}_i } }
     \rho_{ \text{inter}_i } \frac{\sin(qr)} {qr} r^2 dr
 
-    f_{\text{shell}_i} = 4 \pi \int_{\Delta t_{ \text{inter}_i } }
+    f_{\text{shell}_i} &= 4 \pi \int_{\Delta t_{ \text{inter}_i } }
     \rho_{ \text{flat}_i } \frac{\sin(qr)} {qr} r^2 dr =
     3 \rho_{ \text{flat}_i } V ( r_{ \text{inter}_i } +
@@ -67,5 +68,5 @@
     \cos(qr_{\text{inter}_i}) } {qr_{\text{inter}_i}^3} \Big]
 
-    f_\text{solvent} = 4 \pi \int_{r_N}^{\infty} \rho_\text{solvent}
+    f_\text{solvent} &= 4 \pi \int_{r_N}^{\infty} \rho_\text{solvent}
     \frac{\sin(qr)} {qr} r^2 dr =
     3 \rho_\text{solvent} V(r_N)
@@ -80,9 +81,10 @@
 
 .. math::
-    \rho_{{inter}_i} (r) = \begin{cases}
+
+    \rho_{{inter}_i} (r) &= \begin{cases}
     B \exp\Big( \frac {\pm A(r - r_{\text{flat}_i})}
-    {\Delta t_{ \text{inter}_i }} \Big) +C  & \text{for} A \neq 0 \\
+    {\Delta t_{ \text{inter}_i }} \Big) +C  & \mbox{for } A \neq 0 \\
     B \Big( \frac {(r - r_{\text{flat}_i})}
-    {\Delta t_{ \text{inter}_i }} \Big) +C  & \text{for} A = 0 \\
+    {\Delta t_{ \text{inter}_i }} \Big) +C  & \mbox{for } A = 0 \\
     \end{cases}
 
@@ -90,8 +92,9 @@
 
 .. math::
-    \rho_{{inter}_i} (r) = \begin{cases}
+
+    \rho_{{inter}_i} (r) &= \begin{cases}
     \pm B \Big( \frac {(r - r_{\text{flat}_i} )} {\Delta t_{ \text{inter}_i }}
-    \Big) ^A  +C  & \text{for} A \neq 0 \\
-    \rho_{\text{flat}_{i+1}}  & \text{for} A = 0 \\
+    \Big) ^A  +C  & \mbox{for } A \neq 0 \\
+    \rho_{\text{flat}_{i+1}}  & \mbox{for } A = 0 \\
     \end{cases}
 
@@ -101,7 +104,7 @@
     \rho_{{inter}_i} (r) = \begin{cases}
     B \text{erf} \Big( \frac { A(r - r_{\text{flat}_i})}
-    {\sqrt{2} \Delta t_{ \text{inter}_i }} \Big) +C  & \text{for} A \neq 0 \\
+    {\sqrt{2} \Delta t_{ \text{inter}_i }} \Big) +C  & \mbox{for } A \neq 0 \\
     B \Big( \frac {(r - r_{\text{flat}_i} )} {\Delta t_{ \text{inter}_i }}
-    \Big)  +C  & \text{for} A = 0 \\
+    \Big)  +C  & \mbox{for } A = 0 \\
     \end{cases}
 
@@ -114,27 +117,27 @@
 
 .. math::
-    f_{\text{inter}_i} = 4 \pi \int_{\Delta t_{ \text{inter}_i } }
+
+    f_{\text{inter}_i} &= 4 \pi \int_{\Delta t_{ \text{inter}_i } }
     \rho_{ \text{inter}_i } \frac{\sin(qr)} {qr} r^2 dr =
-    4 \pi \sum_{j=0}^{npts_{\text{inter}_i} -1 }
+    4 \pi \sum_{j=1}^{n_\text{steps}}
     \int_{r_j}^{r_{j+1}} \rho_{ \text{inter}_i } (r_j)
-    \frac{\sin(qr)} {qr} r^2 dr \approx
-
-    4 \pi \sum_{j=0}^{npts_{\text{inter}_i} -1 } \Big[
+    \frac{\sin(qr)} {qr} r^2 dr
+
+    &\approx 4 \pi \sum_{j=1}^{n_\text{steps}} \Big[
     3 ( \rho_{ \text{inter}_i } ( r_{j+1} ) - \rho_{ \text{inter}_i }
-    ( r_{j} ) V ( r_{ \text{subshell}_j } )
+    ( r_{j} ) V (r_j)
     \Big[ \frac {r_j^2 \beta_\text{out}^2 \sin(\beta_\text{out})
     - (\beta_\text{out}^2-2) \cos(\beta_\text{out}) }
     {\beta_\text{out}^4 } \Big]
 
-    - 3 ( \rho_{ \text{inter}_i } ( r_{j+1} ) - \rho_{ \text{inter}_i }
-    ( r_{j} ) V ( r_{ \text{subshell}_j-1 } )
+    &{} - 3 ( \rho_{ \text{inter}_i } ( r_{j+1} ) - \rho_{ \text{inter}_i }
+    ( r_{j} ) V ( r_{j-1} )
     \Big[ \frac {r_{j-1}^2 \sin(\beta_\text{in})
     - (\beta_\text{in}^2-2) \cos(\beta_\text{in}) }
     {\beta_\text{in}^4 } \Big]
 
-    + 3 \rho_{ \text{inter}_i } ( r_{j+1} )  V ( r_j )
+    &{} + 3 \rho_{ \text{inter}_i } ( r_{j+1} )  V ( r_j )
     \Big[ \frac {\sin(\beta_\text{out}) - \cos(\beta_\text{out}) }
     {\beta_\text{out}^4 } \Big]
-
     - 3 \rho_{ \text{inter}_i } ( r_{j} )  V ( r_j )
     \Big[ \frac {\sin(\beta_\text{in}) - \cos(\beta_\text{in}) }
@@ -145,10 +148,12 @@
 
 .. math::
-    V(a) = \frac {4\pi}{3}a^3
-
-    a_\text{in} ~ \frac{r_j}{r_{j+1} -r_j} \text{, } a_\text{out}
-    ~ \frac{r_{j+1}}{r_{j+1} -r_j}
-
-    \beta_\text{in} = qr_j \text{, } \beta_\text{out} = qr_{j+1}
+    :nowrap:
+
+    \begin{align*}
+    V(a) &= \frac {4\pi}{3}a^3 && \\
+    a_\text{in} &\sim \frac{r_j}{r_{j+1} -r_j} \text{, } &a_\text{out}
+    &\sim \frac{r_{j+1}}{r_{j+1} -r_j} \\
+    \beta_\text{in} &= qr_j \text{, } &\beta_\text{out} &= qr_{j+1}
+    \end{align*}
 
 
@@ -160,5 +165,5 @@
 .. math::
 
-    P(q) = \frac{[f]^2} {V_\text{particle}} \text{where} V_\text{particle}
+    P(q) = \frac{[f]^2} {V_\text{particle}} \mbox{ where } V_\text{particle}
     = V(r_{\text{shell}_N})
 
@@ -172,5 +177,5 @@
 .. note::
 
-    The outer most radius is used as the effective radius for S(Q)
+    The outer most radius is used as the effective radius for $S(Q)$
     when $P(Q) * S(Q)$ is applied.
 
Index: sasmodels/models/unified_power_Rg.py
===================================================================
--- sasmodels/models/unified_power_Rg.py	(revision ec77322afa4d4f2ab291eb90278bac59a1445f4d)
+++ sasmodels/models/unified_power_Rg.py	(revision 785cbec0749457756eec925df00538ade654c842)
@@ -72,4 +72,5 @@
     ["G[level]",  "1/cm", 400,    [0, inf], "", ""],
     ]
+category = "shape-independent"
 
 def Iq(q, level, rg, power, B, G):